SystemOrganization addCategory: #'Conman-Core'!
SystemOrganization addCategory: #'Conman-Core-Tests'!
SystemOrganization addCategory: #'Conman-Web'!
SystemOrganization addCategory: #'Conman-Meta'!

WAFileLibrary subclass: #CMFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMFileLibrary methodsFor: 'uploaded' stamp: ''!
conmanCss
	^ '/* Colors:
 * Dark blue:	#000099
 * Grey: 		#999999

/* General Formatting */
* {
	font-family: Georgia, serif;
}

body {
	background-color: black;
}

.busy * {
	cursor: progress;
}

/* Heading */
#heading {
	position: absolute;
	top: 0px;
	right: 0px;
	background: #000099 url("crossover.png") no-repeat;
	padding-left: 155px;
	padding-right: 5px;
	height: 60px;
	z-index: 3;
}

#heading h1 {
	margin-top: 2px;
	margin-bottom: 2px;
	font-size: 24pt;
	text-align: right;
	color: #ffcc00;
}

#heading p {
	color: #cccccc;
	margin-top: 2px;
	text-align: right;
	font-size: 8pt;
}

#heading input.editor_field {
	font-size: 21pt;
}

/* Navigation and Menu */
#nav a {
	text-decoration: none;
	font-size: 8pt;
	color: #cccccc;
}

#nav {
	position: absolute;
	padding: 0;
	top: 0px;
	left: 0px;
	background: #000099 url("nav-left.png") no-repeat;
	height: 20px;
	z-index: 3;
}

#nav ul {
	margin: 0;
	padding: 0 0 0 20px;
	height: 20px;
}

#nav li {
	float: left;
	height: 100%;
	padding: 0 0.2em 0 0.2em;
	top: auto;
	bottom: auto;
	list-style: none;
}

#nav li a {
	
}

#nav li.active a {
	color: white;
}

/* Page heading */
#pageHeading {
	position: absolute;
	top: 0;
	left: 0;
	right: 0;
	padding-left: 20px;
	padding-top: 25px;
	margin: 0;
	height: 35px;
	background: #999999 url("nav.png") repeat-x;
	z-index: 2;
}

#pageHeading h2 {
	text-align: left;
	font-size: 18pt;
	margin: 0;
	color: black;
}

/* Page Body */
#pageBody {
	padding: 20px;
	background: white url("top-left.png") no-repeat;
	position: absolute;
	top: 60px;
	bottom: 0px;
	left: 0px;
	right: 0px;
	z-index: 0;
	overflow: auto;
}

/* Content area */
#content {
	position: absolute;
	right: 20px;
	bottom: 0;
	top: 10px;
	left: 17.5em;
}

/* Sidebar view */
#sidebar {
	position: absolute;
	padding-left: 0;
	padding-top: 20px;
	padding-right: 0.5em;
	border-right: dashed 1px #ff9933;
	width: 15em;
	bottom: 0;
	top: 0;
}

#sidebar table {
	font-size: 0.8em;
	border: 0 dashed #999999;
	padding: 0;
	width: 100%;
	margin-bottom: 1em;
	border-spacing: 0;
}

#sidebar table a {
	text-decoration: none;
	color: inherit;
}

#sidebar td.num {
	text-align: right;
	padding-right: 0.5em;
}

#sidebar th {
	font-weight: normal;
}

#sidebar tr.head,#sidebar tr.head:hover {
	background-color: #000099;
	color: #dddddd;
}

#sidebar tr.odd {
	background-color: #dddddd;
}

#sidebar tr.even {
	background-color: #eeeeee;
}

#sidebar tr:hover {
	background-color: #ff9933;
}

#sidebar tr.current,#sidebar tr.current:hover {
	background-color: white;
	color: #999999;
}

#sidebar tr.even td.actions {
	background-color: #eeeeee;
}

#sidebar tr.odd td.actions {
	background-color: #dddddd;
}

#sidebar td.actions a {
	color: #cc6600;
}

#sidebar td.actions a:hover {
	color: #ff9933;
}

/* View */
#view {
	position: absolute;
	bottom: 0;
	top: 0;
	left: 0;
	right: 0;
}

#view h3 {
	margin: 0 0 0.5em 0;
}

#view ul.itemTabs {
	margin: 5px 0 0 0;
	padding-left: 0;
	font-size: 0.8em;
}

#view .itemTabs li {
	display: inline;
	margin: 0;
	padding: 2px 5px 3px 5px;
	background-color: #cccccc;
}

#view .itemTabs a {
	text-decoration: none;
	color: black;
}

#view .itemTabs a:hover {
	color: #cc6600;
}

#view .itemTabs .active {
	background-color: #eeeeee;
}

#view .itemTabs .active a {
	color: #999999;
}

#viewContent {
	margin: 0;
	padding: 0.5em;
	background-color: #eeeeee;
}

#viewContent p {
	margin: 0.1em 0.2em 0.2em 3em;
	text-align: justify;
}

#viewContent .label {
	float: left;
	margin-left: 0;
	font-size: 0.8em;
	font-style: italic;
	width: 3em;
	text-align: right;
	color: #000099;
}

span.fixFloats {
	clear: both;
	display: block;
}

/* Lightbox effects */
div#lightbox {
	background: white;
	border: 1px solid #cc6600;
	padding: 2em;
	width: 10em;
	text-align: center;
}
div#overlay {
	background-color: black;
	filter: alpha(opacity=30);
	-moz-opacity: 0.3;
	opacity: 0.3;
}'! !

!CMFileLibrary methodsFor: 'uploaded' stamp: ''!
crossoverPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 155 0 0 0 60 8 2 0 0 0 254 26 95 141 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 3 29 73 68 65 84 120 218 236 156 77 47 123 65 20 198 79 81 111 11 194 130 8 162 44 72 68 67 132 196 66 8 214 62 96 191 137 216 88 80 68 90 141 72 211 160 26 213 168 86 27 165 84 83 245 118 158 255 109 234 61 146 134 127 110 167 207 47 99 50 238 238 222 95 207 153 115 103 58 117 136 120 132 24 68 29 31 1 141 18 26 37 52 74 104 148 208 40 141 18 26 37 52 74 104 148 208 40 141 18 26 37 52 74 104 148 208 40 141 18 26 37 52 74 126 157 6 143 71 138 69 137 199 223 93 77 165 36 159 47 141 175 174 228 250 26 131 179 51 121 124 148 251 123 57 63 231 115 179 177 81 253 115 58 101 96 224 221 213 15 255 126 73 44 6 193 218 91 142 245 19 160 159 131 104 148 143 212 6 70 43 163 191 31 189 203 245 241 122 50 41 23 23 232 19 9 57 61 197 184 28 238 196 214 70 191 163 187 27 205 237 126 189 146 205 194 174 58 214 128 214 62 28 150 135 7 62 249 234 49 250 153 182 54 180 225 225 215 43 145 8 188 106 127 124 12 223 164 202 140 126 102 104 8 205 66 211 178 170 61 56 128 93 141 96 82 149 70 223 210 213 133 54 51 131 241 205 13 98 119 127 95 130 65 212 216 164 2 28 30 143 77 79 73 232 203 210 222 158 132 66 114 120 72 77 70 24 125 91 88 5 2 176 171 129 75 76 48 90 38 151 147 221 93 217 222 70 102 38 38 24 45 147 78 203 214 150 108 108 112 174 53 197 104 25 157 101 53 100 53 39 23 10 84 105 132 81 11 213 233 247 139 215 203 108 108 138 209 50 177 152 172 173 201 206 14 246 30 106 150 250 229 229 101 99 110 166 189 93 198 199 101 126 94 154 155 177 121 80 155 169 216 168 24 125 203 211 19 10 99 13 217 90 75 197 13 166 222 88 93 157 76 77 161 105 42 94 93 21 159 15 142 153 117 13 73 197 147 147 88 101 124 126 198 58 148 241 94 205 55 106 209 218 42 99 99 152 98 157 78 120 53 184 116 170 21 163 22 141 141 50 50 34 139 139 216 221 75 36 228 238 142 70 205 184 231 122 25 28 148 133 5 236 249 164 82 216 240 161 81 35 170 124 135 244 245 33 15 187 92 88 86 204 100 88 235 154 130 219 141 22 137 200 202 10 118 120 24 163 134 208 209 33 211 211 168 138 181 104 210 210 73 11 99 26 53 1 173 152 38 38 100 110 14 57 57 30 175 202 111 184 209 232 23 52 53 201 232 40 74 39 125 151 173 186 146 152 70 191 47 49 26 80 18 47 45 73 111 47 234 166 106 41 157 104 244 103 122 122 100 118 22 213 147 38 225 100 210 238 171 78 198 174 212 255 17 185 28 246 216 215 215 237 123 248 135 70 43 36 28 134 87 191 223 118 11 138 52 250 11 33 235 245 226 133 135 70 141 66 147 176 207 39 155 155 114 121 73 163 102 17 137 96 225 73 237 166 211 52 106 22 154 135 3 1 156 248 56 57 161 81 179 200 231 113 208 67 91 40 244 63 166 91 174 212 255 57 45 45 248 62 155 54 249 119 84 235 232 8 118 131 65 28 202 99 140 26 69 54 11 181 26 181 86 251 173 121 151 70 237 66 161 80 82 27 141 162 114 214 65 101 191 118 64 163 246 69 95 132 84 173 246 137 132 220 222 98 156 201 252 124 36 158 243 168 125 233 236 68 251 210 180 206 199 197 98 105 37 82 125 91 223 53 183 174 188 8 48 0 137 206 116 80 50 162 251 137 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!CMFileLibrary methodsFor: 'uploaded' stamp: ''!
navPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 1 0 0 0 20 8 2 0 0 0 195 108 192 246 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 0 20 73 68 65 84 120 218 98 98 96 152 201 196 192 192 64 45 12 16 96 0 52 229 0 194 193 193 233 219 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!CMFileLibrary methodsFor: 'uploaded' stamp: ''!
navleftPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 20 0 0 0 20 8 2 0 0 0 2 235 138 90 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 0 204 73 68 65 84 120 218 164 148 61 10 131 64 16 70 63 23 45 82 164 177 23 196 34 96 163 96 35 226 5 196 220 192 194 214 198 210 187 136 119 177 243 12 122 0 75 123 17 187 124 169 2 98 80 199 7 219 237 99 102 231 103 181 186 110 170 10 243 12 1 74 41 184 46 100 40 158 215 235 134 28 4 76 64 42 63 159 240 125 169 76 194 240 134 204 200 166 41 149 249 230 52 149 202 36 138 46 7 255 201 186 142 36 145 202 36 142 97 89 82 153 193 179 236 66 207 183 23 29 7 239 183 84 38 44 251 201 105 87 123 187 130 162 128 109 139 100 242 120 160 44 143 253 191 197 225 192 115 207 185 51 18 153 24 198 55 255 60 255 38 178 139 126 248 48 54 223 243 208 182 232 186 237 135 163 53 77 115 178 49 235 138 97 64 223 99 28 177 44 152 38 124 4 24 0 55 19 35 197 40 67 124 174 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!CMFileLibrary methodsFor: 'uploaded' stamp: ''!
topleftPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 20 0 0 0 20 8 2 0 0 0 2 235 138 90 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 0 211 73 68 65 84 120 218 156 147 187 10 133 48 12 64 211 82 20 81 196 87 17 5 23 21 29 156 116 117 17 5 255 209 239 116 22 110 4 225 122 241 113 219 156 173 109 14 77 147 148 45 203 2 10 184 174 155 166 169 148 50 12 67 206 185 101 89 182 109 139 119 199 52 205 186 174 203 178 140 162 232 122 250 40 11 33 154 166 105 219 214 48 140 199 152 219 221 32 8 230 121 198 84 223 243 186 145 243 60 31 134 1 111 254 91 8 113 53 167 105 98 140 169 84 145 159 23 73 146 140 227 168 104 254 200 88 88 52 177 13 160 204 55 180 239 123 108 29 232 112 200 113 28 99 51 65 147 67 238 186 14 244 217 101 223 247 179 44 35 202 85 85 1 137 93 46 138 130 40 227 36 58 142 67 148 177 206 64 133 227 23 165 203 158 231 145 101 182 174 43 249 205 108 219 54 173 121 62 243 17 96 0 190 204 21 162 12 101 219 221 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!SUElement methodsFor: '*conman' stamp: 'srh 6/3/2007 13:10'!
collect: aBlock
	self call: 'collect' argument: 
		((SUFunction on: self canvas block: aBlock arguments: 
			(Array with: SUElementReference)) return: true).! !

!SUElement methodsFor: '*conman' stamp: 'srh 6/3/2007 12:32'!
each: aBlock
	self call: 'each' argument: 
		(SUFunction on: self canvas block: aBlock arguments: 
			(Array with: SUElementReference)).! !

!SUElement methodsFor: '*conman' stamp: 'srh 6/3/2007 11:50'!
invoke: aString arguments: anArray
	self call: 'invoke' arguments: (Array with: aString), anArray! !

!SUElement methodsFor: '*conman' stamp: 'srh 6/3/2007 13:11'!
pluck: aString
	self call: 'pluck' argument: aString! !

Object subclass: #CMConvention
	instanceVariableNames: 'rooms events participants name filename'
	classVariableNames: 'Suffix Prefix'
	poolDictionaries: ''
	category: 'Conman-Core'!

!CMConvention class methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:44'!
deserialize: aString
	^Object readSixxFrom: aString! !

!CMConvention class methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:47'!
filenameFrom: aFilename
	" Use a template to create a filename from the unique portion "
	^ Prefix, aFilename , Suffix.! !

!CMConvention class methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:48'!
initialize
	super initialize.
	Prefix := 'Conman-'.
	Suffix := '.xml'.! !

!CMConvention class methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:49'!
listSaved
	^ (FileDirectory default fileNamesMatching: Prefix, '*', Suffix) collect: [ :n|
		n copyFrom: Prefix size + 1 to: n size - Suffix size ].! !

!CMConvention class methodsFor: 'as yet unclassified' stamp: 'srh 10/13/2008 20:49'!
loadFrom: aFilename
	| fstream c |
	fstream := FileDirectory default readOnlyFileNamed: (self filenameFrom: aFilename).
	c := Object readSixxFrom: fstream.
	fstream close.
	c filename: aFilename.
	^c! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:49'!
addEvent: anEvent
	events add: anEvent.! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:50'!
addParticipant: aParticipant
	participants add: aParticipant! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:49'!
addRoom: aRoom
	rooms add: aRoom! !

!CMConvention methodsFor: 'accessing' stamp: 'srh 5/24/2007 20:48'!
events
	^events! !

!CMConvention methodsFor: 'accessing' stamp: 'srh 10/13/2008 21:04'!
filename
	^filename! !

!CMConvention methodsFor: 'accessing' stamp: 'srh 10/13/2008 20:50'!
filename: aFilename
	filename := aFilename! !

!CMConvention methodsFor: 'initialization' stamp: 'srh 5/24/2007 20:38'!
initialize
	rooms := Set new.
	events := Set new.
	participants := Set new.! !

!CMConvention methodsFor: 'accessing' stamp: 'srh 5/29/2007 23:11'!
name
	^name! !

!CMConvention methodsFor: 'accessing' stamp: 'srh 5/29/2007 23:10'!
name: aName
	name := aName.! !

!CMConvention methodsFor: 'accessing' stamp: 'srh 5/24/2007 20:48'!
participants
	^participants! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:09'!
removeEvent: anEvent
	anEvent dispose.
	events remove: anEvent.! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:17'!
removeParticipant: aParticipant
	aParticipant dispose.
	participants remove: aParticipant.! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:11'!
removeRoom: aRoom
	aRoom dispose.
	rooms remove: aRoom.! !

!CMConvention methodsFor: 'accessing' stamp: 'srh 5/24/2007 20:48'!
rooms
	^rooms! !

!CMConvention methodsFor: 'actions' stamp: 'srh 10/13/2008 20:50'!
save
	self saveAs: filename! !

!CMConvention methodsFor: 'actions' stamp: 'srh 10/13/2008 21:05'!
saveAs: aFilename
	| fstream |
	fstream := FileDirectory default forceNewFileNamed: (CMConvention filenameFrom: aFilename).
	fstream write: self serialize.
	fstream close.! !

!CMConvention methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:43'!
serialize
	" Convert the Convention and its members to a string that can be used
	 to reconstitute the Convention via CMConvention deserialise:"
	
	^self sixxString.! !

Object subclass: #CMEvent
	instanceVariableNames: 'description duration name participants room'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core'!

!CMEvent methodsFor: 'as yet unclassified' stamp: 'srh 5/23/2007 23:21'!
add: aParticipant
	participants add: aParticipant.
	aParticipant myAddEvent: self! !

!CMEvent methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 15:38'!
deschedule
	room ifNotNil: [room deschedule: self].! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:14'!
description
	^ description! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:14'!
description: anObject
	description := anObject! !

!CMEvent methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:10'!
dispose
	self deschedule.
	participants do: [ :p | self remove: p].! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:14'!
duration
	^ duration! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:14'!
duration: anObject
	duration := anObject! !

!CMEvent methodsFor: 'initialize-release' stamp: 'srh 5/23/2007 22:32'!
initialize
	participants := Set new! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
name
	^ name! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:14'!
name: anObject
	name := anObject! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:14'!
participants
	^ participants! !

!CMEvent methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 07:22'!
remove: aParticipant
	participants remove: aParticipant.
	aParticipant myRemoveEvent: self! !

!CMEvent methodsFor: 'accessing' stamp: 'srh 5/24/2007 15:16'!
room
	^room! !

!CMEvent methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 15:12'!
scheduleAt: aTime in: aRoom
	aRoom schedule: self at: aTime.! !

!CMEvent methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 15:07'!
scheduled
	^room notNil.! !

!CMEvent methodsFor: 'private' stamp: 'srh 5/24/2007 15:08'!
setRoom: aRoom
	room := aRoom! !

!CMEvent methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:16'!
time
	^ room scheduleFor: self! !

Object subclass: #CMParticipant
	instanceVariableNames: 'bio name events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core'!

CMParticipant class
	instanceVariableNames: 'events'!

CMParticipant class
	instanceVariableNames: 'events'!

!CMParticipant methodsFor: 'as yet unclassified' stamp: 'srh 5/23/2007 23:23'!
attend: anEvent
	anEvent add: self! !

!CMParticipant methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
bio
	^ bio! !

!CMParticipant methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
bio: anObject
	bio := anObject! !

!CMParticipant methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:18'!
dispose
	events do: [ :e | self unattend: e].! !

!CMParticipant methodsFor: 'accessing' stamp: 'srh 5/23/2007 23:20'!
events
	^events! !

!CMParticipant methodsFor: 'as yet unclassified' stamp: 'srh 5/31/2007 20:22'!
initialize
	events := Set new.
	bio := ''! !

!CMParticipant methodsFor: 'private' stamp: 'srh 5/23/2007 23:19'!
myAddEvent: anEvent
	events add: anEvent.! !

!CMParticipant methodsFor: 'private' stamp: 'srh 5/24/2007 07:22'!
myRemoveEvent: anEvent
	events remove: anEvent! !

!CMParticipant methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:16'!
name
	^ name! !

!CMParticipant methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
name: anObject
	name := anObject! !

!CMParticipant methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:16'!
timetable
	| t |
	t := SortedCollection sortBlock: [ :a :b | a time < b time].
	events do: [ :event | 
		event scheduled ifTrue: [
			t add: (CMScheduleItem newEvent: event in: event room at: event time) 
		]].
	^t.! !

!CMParticipant methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 07:19'!
unattend: anEvent
	anEvent remove: self! !

Object subclass: #CMRoom
	instanceVariableNames: 'capacity description name schedule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core'!

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
capacity
	^ capacity! !

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
capacity: anObject
	capacity := anObject! !

!CMRoom methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 15:27'!
deschedule: anEvent
	(schedule includesKey: anEvent) ifTrue: [
		schedule removeKey: anEvent.
		anEvent setRoom: nil.
	].! !

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
description
	^ description! !

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
description: anObject
	description := anObject! !

!CMRoom methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:14'!
dispose
	schedule keys do: [ :e | self deschedule: e ].! !

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/24/2007 15:15'!
events
	^schedule keys! !

!CMRoom methodsFor: 'as yet unclassified' stamp: 'srh 5/31/2007 20:22'!
initialize
	schedule := Dictionary new.
	description := ''! !

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:16'!
name
	^ name! !

!CMRoom methodsFor: 'accessing' stamp: 'srh 5/23/2007 22:15'!
name: anObject
	name := anObject! !

!CMRoom methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 15:37'!
schedule: anEvent at: aDateAndTime
	anEvent deschedule.
	schedule at: anEvent put: aDateAndTime.
	anEvent setRoom: self! !

!CMRoom methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 15:15'!
scheduleFor: anEvent
	^schedule at: anEvent! !

Object subclass: #CMScheduleItem
	instanceVariableNames: 'room event time'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core'!

!CMScheduleItem class methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:09'!
newEvent: anEvent in: aRoom at: aTime
	^(self new) setEvent: anEvent room: aRoom time: aTime.! !

!CMScheduleItem methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:06'!
event
	^event! !

!CMScheduleItem methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:06'!
room
	^room! !

!CMScheduleItem methodsFor: 'private' stamp: 'srh 5/24/2007 20:09'!
setEvent: anEvent room: aRoom time: aTime
	room := aRoom.
	event := anEvent.
	time := aTime.! !

!CMScheduleItem methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:06'!
time
	^time! !

WASession subclass: #CMSession
	instanceVariableNames: 'convention ajax inlineEdit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMSession methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 23:31'!
ajax
	^ajax! !

!CMSession methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 23:31'!
ajax: aBoolean
	ajax := aBoolean! !

!CMSession methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 22:18'!
convention
	^convention.! !

!CMSession methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 22:18'!
convention: aCMConvention
	convention := aCMConvention.! !

!CMSession methodsFor: 'as yet unclassified' stamp: 'srh 9/21/2007 21:25'!
initialize
	super initialize.
	ajax := false.
	inlineEdit := true.! !

!CMSession methodsFor: 'as yet unclassified' stamp: 'srh 5/31/2007 20:41'!
inlineEdit
	^ajax and: inlineEdit! !

!CMSession methodsFor: 'as yet unclassified' stamp: 'srh 5/31/2007 20:34'!
inlineEdit: aBoolean
	inlineEdit := aBoolean! !

WAComponent subclass: #CMComponent
	instanceVariableNames: 'enabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMComponent methodsFor: 'accessing' stamp: 'srh 5/29/2007 23:16'!
convention
	^self session convention! !

!CMComponent methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 22:11'!
disable
	enabled := false.! !

!CMComponent methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:16'!
enable
	enabled := self convention notNil.! !

!CMComponent methodsFor: 'testing' stamp: 'srh 5/29/2007 22:10'!
enabled
	^enabled! !

!CMComponent methodsFor: 'initialize-release' stamp: 'srh 5/29/2007 22:10'!
initialize
	super initialize.
	enabled := true.! !

!CMComponent methodsFor: 'rendering' stamp: 'srh 5/31/2007 20:37'!
lightbox: aComponent
	self session ajax 
		ifTrue: [ ^super lightbox: aComponent ] 
		ifFalse: [ ^self call: aComponent ].! !

!CMComponent methodsFor: 'rendering' stamp: 'srh 9/21/2007 23:15'!
renderField: anInputType on: aSelector of: anObject titled: aTitle on: html 
	html div: 
			[(html label)
				class: #label;
				for: aSelector;
				with: aTitle , ': '.
			(html perform: anInputType)
				on: aSelector of: anObject;
				id: aSelector]! !

!CMComponent methodsFor: 'specialisation' stamp: 'srh 10/7/2007 20:49'!
title
	^self subclassResponsibility.! !

!CMComponent methodsFor: 'rendering' stamp: 'srh 6/3/2007 21:59'!
updateId: anId callback: aBlock perform: aSelector on: html
	^(html anchor callback: aBlock; onClick: (self session ajax ifTrue: [
		html updater id: anId; callback: [ :r | aBlock value. self perform: aSelector with: r]; return: false 
	]))
! !

CMComponent subclass: #CMConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMConfiguration methodsFor: 'as yet unclassified' stamp: 'srh 5/31/2007 21:04'!
renderContentOn: html
	html form: [
		self renderField: #checkbox on: #ajax of:  self session titled:  'Enable Ajax' on: html.
		self session ajax ifTrue: [
			self renderField: #checkbox on: #inlineEdit of: self session titled: 'Use inline editing' on: html.
		].
		html submitButton value: 'Save'.
	]! !

!CMConfiguration methodsFor: 'as yet unclassified' stamp: 'srh 5/31/2007 20:25'!
title
	^'Configuration'! !

CMComponent subclass: #CMConman
	instanceVariableNames: 'children content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMConman class methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 21:45'!
canBeRoot
	^true! !

!CMConman class methodsFor: 'as yet unclassified' stamp: 'srh 6/5/2007 20:43'!
registerAsApplication: aString
	^(super registerAsApplication: aString)
		addLibrary: CMFileLibrary;
		addLibrary: SULibrary;
		preferenceAt: #sessionClass put: CMSession;
		yourself
! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 22:04'!
children
	^Array with: content.! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 10/7/2007 20:48'!
initialize
	super initialize.
	children := OrderedCollection new.
	content := children add: CMHome new.
	children add: CMSchedule new.
	children add: CMRooms new.
	children add: CMParticipants new.
	children add: CMEvents new.
	children add: CMLoadSave new.
	children add: CMConfiguration new.! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 9/21/2007 20:33'!
renderContentOn: html 
	html script: (
		SUResponders new 
			onCreate: (SUSelector new do: [ :e | e element  addClassName: #busy]);
			onComplete: (SUSelector new do: [ :e | e element  removeClassName: #busy])
	).

	(html div)
		id: 'heading';
		with: [self renderHeadingOn: html].
	(html div)
		id: 'nav';
		with: [self renderNavOn: html].
	(html div)
		id: 'pageHeading';
		with: [self renderPageHeadingOn: html].
	(html div)
		id: 'pageBody';
		with: [self renderPageBodyOn: html]! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 6/3/2007 20:16'!
renderHeadingOn: html
	self convention isNil  
		ifTrue: [ html heading level: 1; with: [html space] ]
		ifFalse: [		 
			html heading 
				level: 1; 
				script: (self session inlineEdit ifTrue: [
				html inPlaceEditor 
					triggerInPlaceEditor: [ :value | self convention name: value ];
					callback: [ :r | r render: self convention name ]
				]);
			with: self convention name 	
		].
	html paragraph: 'Conman convention management system'! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 9/21/2007 20:35'!
renderNavOn: html.
	html unorderedList: [ 
		children do: [ :c | 
			| id |
			id := html nextId.
			c enabled ifTrue: [
				html listItem id: id; class: ((c = content) ifTrue:  ['active'] ifFalse: ['']); with: [ 
					html anchor 
						callback: [ content := c ]; 
						onClick:(self session ajax ifTrue: [
							(
							html evaluator callback: [ :script | 
								content := c.
								script element id: 'pageHeading'; render: [ :r | self renderPageHeadingOn: r].
								script element id: 'pageBody'; render: [ :r | self renderPageBodyOn: r ].
								(script element id: id) siblings invoke: #removeClassName with: #active.
								script element id: id; addClassName: #active.
							]; 
							return: false)
						]);
						with: c title.
				]
			]
		].	
].! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 6/3/2007 13:36'!
renderPageBodyOn: html 
	html render: content! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 6/3/2007 13:36'!
renderPageHeadingOn: html
	html heading level: 2; with: content title.! !

!CMConman methodsFor: 'as yet unclassified' stamp: 'srh 6/2/2007 23:04'!
updateRoot: anHtmlRoot
	| t |
	super updateRoot: anHtmlRoot.
	t := 'Conman'.
	self convention ifNotNil: [ t := t, ': ', self convention name ].
	anHtmlRoot 
		title: t.
	anHtmlRoot	stylesheet 
		url: CMFileLibrary  / #conmanCss! !

CMComponent subclass: #CMHome
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMHome methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:16'!
enabled
	^true! !

!CMHome methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 21:50'!
renderContentOn: html
	self convention ifNotNil: [
		html paragraph: 'Events: ', self convention events size printString.
		html paragraph: 'Rooms: ', self convention rooms size printString.
		html paragraph: 'Participants: ', self convention participants size printString.
	]! !

!CMHome methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 22:15'!
title
	^'Home'! !

CMComponent subclass: #CMLister
	instanceVariableNames: 'viewer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

CMLister subclass: #CMEvents
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMEvents methodsFor: 'data-access' stamp: 'srh 5/31/2007 21:26'!
items
	^self convention events! !

!CMEvents methodsFor: 'rendering' stamp: 'srh 6/3/2007 20:13'!
renderHeadersOn: html
	html tableHeading: 'Name'.
	html tableHeading: 'Room'.
	html tableHeading: 'Day'.
	html tableHeading: 'Time'.
	html tableHeading: 'Ptpts'.
! !

!CMEvents methodsFor: 'rendering' stamp: 'srh 9/23/2007 17:58'!
renderRow: anEvent on: html
	html 
		tableData: [ 
			self selectField: anEvent name callback: [ viewer item: anEvent ] on: html
		].
	anEvent scheduled ifTrue: [
		html
			tableData: anEvent room name;
			tableData: anEvent time dayOfWeekAbbreviation, ', ', (anEvent time asDate printFormat: #(2 1 0 ' ' 2 1));
			tableData: (String streamContents: [ :aStream | anEvent time asTime print24: true showSeconds: false on: aStream ])
	] ifFalse: [
		html
			tableData colSpan: 3; align: #center; with: [ html emphasis: '(unscheduled)' ]
	].
	html tableData class: 'num'; with: anEvent participants size printString.! !

!CMEvents methodsFor: 'specialisation' stamp: 'srh 5/31/2007 21:13'!
title
	^'Events'! !

!CMEvents methodsFor: 'specialisation' stamp: 'srh 5/31/2007 22:31'!
viewerClass
	^CMEventView! !

!CMLister methodsFor: 'accessing' stamp: 'srh 9/23/2007 13:02'!
children
	^Array with: viewer.! !

!CMLister methodsFor: 'testing' stamp: 'srh 5/31/2007 22:27'!
enabled
	^self convention notNil! !

!CMLister methodsFor: 'initialize-release' stamp: 'srh 9/23/2007 13:00'!
initialize
	super initialize.
	viewer := self viewerClass new.
! !

!CMLister methodsFor: 'data-access' stamp: 'srh 5/31/2007 22:31'!
items
	^self subclassResponsibility.! !

!CMLister methodsFor: 'rendering' stamp: 'srh 9/23/2007 15:50'!
renderActionsFor: anItem on: html
	html tableData class: 'actions'; with: [ 
		html anchor callback: [ viewer delete: anItem ]; with: '(x)'
	].
! !

!CMLister methodsFor: 'rendering' stamp: 'srh 9/23/2007 15:51'!
renderContentOn: html
	| odd | odd := true.
	
	html div id: #content; with: [ self renderItemOn: html ].
	html div id: #sidebar; with: [
		html table: [
			html tableRow class: #head; with: [ self renderHeadersOn: html. html tableHeading: '' ].
			self items do: [ :i | 
				html tableRow 
					class: ( odd ifTrue: [ #odd ] ifFalse: [ #even ] );
					with: [ 
						self renderRow: i on: html.
						self renderActionsFor: i on: html ].
				odd := odd not.
			]
		].
		html anchor callback: [ viewer add ]; with: 'Add'.
	]
! !

!CMLister methodsFor: 'rendering' stamp: 'srh 5/31/2007 22:39'!
renderHeadersOn: html
	^self subclassResponsibility.! !

!CMLister methodsFor: 'rendering' stamp: 'srh 9/23/2007 13:05'!
renderItemOn: html
	html div id: 'view'; with: [
			html render: viewer.
	].! !

!CMLister methodsFor: 'rendering' stamp: 'srh 5/31/2007 22:40'!
renderRow: anItem on: html
	^self subclassResponsibility.! !

!CMLister methodsFor: 'rendering' stamp: 'srh 6/3/2007 22:00'!
selectField: data callback: aBlock on: html
	(self 
		updateId: #content
		callback: aBlock
		perform: #renderItemOn: 
		on: html) with:  data! !

!CMLister methodsFor: 'specialisation' stamp: 'srh 5/31/2007 22:30'!
viewerClass
	^self subclassResponsibility.! !

CMLister subclass: #CMParticipants
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMParticipants methodsFor: 'data-access' stamp: 'srh 5/31/2007 23:58'!
items
	^self convention participants! !

!CMParticipants methodsFor: 'rendering' stamp: 'srh 5/31/2007 23:56'!
renderHeadersOn: html
	html tableHeading: 'Name'.
	html tableHeading: 'Events'! !

!CMParticipants methodsFor: 'rendering' stamp: 'srh 9/23/2007 15:49'!
renderRow: aParticipant on: html
	html tableData: 
		[ self selectField: aParticipant name callback: [ viewer item: aParticipant ] on: html ].
	html tableData 
		class: #num; 
		with: aParticipant events size printString! !

!CMParticipants methodsFor: 'specialisation' stamp: 'srh 5/31/2007 21:07'!
title
	^'Participants'! !

!CMParticipants methodsFor: 'specialisation' stamp: 'srh 5/31/2007 23:59'!
viewerClass
	^CMParticipantView! !

CMLister subclass: #CMRooms
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMRooms methodsFor: 'as yet unclassified' stamp: 'srh 6/1/2007 00:05'!
items
	^self convention rooms! !

!CMRooms methodsFor: 'as yet unclassified' stamp: 'srh 6/1/2007 00:05'!
renderHeadersOn: html
	html tableHeading: 'Name'.
	html tableHeading: 'Events'.! !

!CMRooms methodsFor: 'as yet unclassified' stamp: 'srh 9/23/2007 17:58'!
renderRow: anItem on: html
	html tableData: [ self selectField: anItem name callback: [ viewer item: anItem ] on: html ].
	html tableData: anItem events size printString.! !

!CMRooms methodsFor: 'as yet unclassified' stamp: 'srh 6/1/2007 00:03'!
title
	^'Rooms'! !

!CMRooms methodsFor: 'as yet unclassified' stamp: 'srh 6/1/2007 00:03'!
viewerClass
	^CMRoomView! !

CMComponent subclass: #CMLoadSave
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMLoadSave methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:16'!
enabled
	^true! !

!CMLoadSave methodsFor: 'as yet unclassified' stamp: 'srh 10/13/2008 21:15'!
renderContentOn: html
	self renderSaveBoxOn: html.
	self renderLoadListOn: html.
	self renderOtherOn: html! !

!CMLoadSave methodsFor: 'as yet unclassified' stamp: 'srh 10/13/2008 21:13'!
renderLoadListOn: html
	html form: [ html fieldSet legend: 'Load Convention'; with: [
		html select callback: [ :value | self session convention: (CMConvention loadFrom: value)  ];
			list: CMConvention listSaved.
		html submitButton value: 'Load'. ]].
	! !

!CMLoadSave methodsFor: 'as yet unclassified' stamp: 'srh 10/13/2008 21:15'!
renderOtherOn: html
	html fieldSet legend: 'Other Actions'; with: [
		html anchor callback: [ self session convention: nil ]; with: 'New Convention'.
	]! !

!CMLoadSave methodsFor: 'as yet unclassified' stamp: 'srh 10/13/2008 21:23'!
renderSaveBoxOn: html
	| con legend  |
	con := self session convention.
	legend := 'Update and Save'.
	con ifNil: [con := CMConvention new. legend := 'New Convention'] .

	html form: [
		html fieldSet legend: legend; with: [
		html label for: 'conname'; with: 'Convention Name: '.
		html textInput id: 'conname'; on: #name of: con.
		html label for: 'filename'; with: 'Filename: '.
		html textInput id: 'filename'; on: #filename of: con.
		html submitButton value: 'Save'; callback: [ con save. self session convention: con ].
		]
	].! !

!CMLoadSave methodsFor: 'as yet unclassified' stamp: 'srh 10/13/2008 20:47'!
title
	^'Convention'! !

CMComponent subclass: #CMSchedule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMSchedule methodsFor: 'as yet unclassified' stamp: 'srh 10/7/2007 20:51'!
enabled
	^self convention notNil! !

!CMSchedule methodsFor: 'as yet unclassified' stamp: 'srh 10/7/2007 20:50'!
title
	^'Schedule'! !

CMComponent subclass: #CMViewer
	instanceVariableNames: 'item mode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

CMViewer subclass: #CMEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMEditor class methodsFor: 'instance creation' stamp: 'srh 5/31/2007 23:41'!
for: anItem
	^self new item: anItem! !

!CMEditor methodsFor: 'actions' stamp: 'srh 9/23/2007 17:51'!
add
	mode := #new.
	item := self newItem.! !

!CMEditor methodsFor: 'data-access' stamp: 'srh 9/23/2007 13:09'!
addItem: anItem
	^self subclassResponsibility.! !

!CMEditor methodsFor: 'actions' stamp: 'srh 9/23/2007 17:52'!
cancel
	(mode = #new) ifTrue: [ item := nil ].
	mode := #details! !

!CMEditor methodsFor: 'actions' stamp: 'srh 9/23/2007 13:02'!
delete: anObject
	(self lightbox: (WAYesOrNoDialog new addMessage: 'Are you sure you want to delete ', anObject name, '?'; yourself))
		ifTrue: [
			self removeItem: anObject.
		]! !

!CMEditor methodsFor: 'as yet unclassified' stamp: 'srh 9/23/2007 11:30'!
inPlaceEditorFor: aSelector on: html
	^self inPlaceEditorFor: aSelector on: html rows: 1 cols: nil.! !

!CMEditor methodsFor: 'as yet unclassified' stamp: 'srh 9/23/2007 11:31'!
inPlaceEditorFor: aSelector on: html rows: rows
	^self inPlaceEditorFor: aSelector  on:  html rows: rows cols: nil! !

!CMEditor methodsFor: 'as yet unclassified' stamp: 'srh 10/6/2008 15:30'!
inPlaceEditorFor: aSelector on: html rows: rows cols: cols 
	| setter |
	setter := (aSelector, ':') asSymbol.
	
	^(self session inlineEdit 
			ifTrue: [html inPlaceEditor 
				cancelControl: false;
				triggerInPlaceEditor: [ :value | item perform: setter with: value ];
				rows: rows;
				size: cols;
				callback: [ :r | r render: (item perform: aSelector) asHtml]
			])! !

!CMEditor methodsFor: 'data-access' stamp: 'srh 9/23/2007 13:04'!
newItem
	^self subclassResponsibility.! !

!CMEditor methodsFor: 'data-access' stamp: 'srh 9/23/2007 13:04'!
removeItem: anItem
	^super subclassResponsibility.! !

!CMEditor methodsFor: 'as yet unclassified' stamp: 'srh 10/7/2007 20:32'!
renderContentOn: html
	((mode = #edit) or: [mode = #new]) ifFalse: [ super renderContentOn: html.] ifTrue: [
		html form: [
			self renderEditTitleOn: html.
			html div id: #viewContent; with: [	
				self renderEditFieldsOn: html.
				html submitButton on: #save of: self.
				html cancelButton on: #cancel of: self ]]
	]
! !

!CMEditor methodsFor: 'rendering' stamp: 'srh 5/31/2007 23:38'!
renderTextArea: aName for: aSelector on: html
	self renderField: #textArea on: aSelector  of: item titled: aName on: html! !

!CMEditor methodsFor: 'rendering' stamp: 'srh 5/31/2007 23:38'!
renderTextInput: aName for: aSelector on: html
	self renderField: #textInput on: aSelector  of: item titled: aName on: html! !

!CMEditor methodsFor: 'rendering' stamp: 'srh 9/21/2007 23:11'!
renderTitleField: aName for: aSelector on: html
	self renderField: #textInput on: aSelector  of: item titled: aName on: html! !

!CMEditor methodsFor: 'actions' stamp: 'srh 9/23/2007 17:57'!
save
	(mode = #new) ifTrue: [
		self addItem: item.
	].
	mode := #details! !

CMEditor subclass: #CMEventView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMEventView methodsFor: 'data-access' stamp: 'srh 9/23/2007 13:05'!
addItem: anEvent
	self convention addEvent: anEvent! !

!CMEventView methodsFor: 'data-access' stamp: 'srh 9/23/2007 13:05'!
newItem
	^CMEvent new.! !

!CMEventView methodsFor: 'as yet unclassified' stamp: 'srh 10/7/2007 20:41'!
renderDetailsOn: html
	html paragraph class: #label; with: 'Info'.
	html paragraph 
		script: (self inPlaceEditorFor: #description on: html rows: 6);
		with: [html html:  self item description asHtml] .
! !

!CMEventView methodsFor: 'as yet unclassified' stamp: 'srh 9/23/2007 11:13'!
renderEditFieldsOn: html
	self renderTextArea: 'Info' for: #description on: html! !

!CMEventView methodsFor: 'as yet unclassified' stamp: 'srh 9/23/2007 11:25'!
renderEditTitleOn: html
	self renderTitleField: 'Name' for: #name on: html.! !

CMEditor subclass: #CMParticipantView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMParticipantView methodsFor: 'data-access' stamp: 'srh 9/23/2007 13:08'!
addItem: anItem
	self convention addParticipant: anItem! !

!CMParticipantView methodsFor: 'as yet unclassified' stamp: 'srh 6/3/2007 22:07'!
initialize
	super initialize.
	mode := #details! !

!CMParticipantView methodsFor: 'as yet unclassified' stamp: 'srh 9/23/2007 10:32'!
modes
	^#(#events)! !

!CMParticipantView methodsFor: 'data-access' stamp: 'srh 9/23/2007 13:08'!
newItem
	^CMParticipant new! !

!CMParticipantView methodsFor: 'data-access' stamp: 'srh 9/23/2007 13:08'!
removeItem: anItem
	self convention removeParticipant: anItem! !

!CMParticipantView methodsFor: 'as yet unclassified' stamp: 'srh 10/7/2007 20:40'!
renderDetailsOn: html
	html paragraph class: #label; with: 'Bio'.
	html paragraph 
		script: (self inPlaceEditorFor: #bio on: html rows: 6);
		with: [ html html: self item bio asHtml . ]
! !

!CMParticipantView methodsFor: 'as yet unclassified' stamp: 'srh 9/23/2007 11:13'!
renderEditFieldsOn: html
	self renderTextArea: 'Bio' for: #bio on: html.
! !

!CMParticipantView methodsFor: 'as yet unclassified' stamp: 'srh 9/23/2007 11:26'!
renderEditTitleOn: html
	self renderTitleField: 'Name' for: #name on: html.
! !

!CMParticipantView methodsFor: 'as yet unclassified' stamp: 'srh 6/3/2007 21:43'!
renderEventsOn: html
	| t lastDate |
	t := SortedCollection sortBlock: [ :a :b | 
		(a scheduled and: [ b scheduled ]) 
			ifTrue: [a time < b time] 
			ifFalse: [
				a scheduled 
					ifTrue: [b]
					ifFalse: [b scheduled ifTrue: [a] ifFalse: [ a name < b name ] ]
			]
	].
	item events do: [ :event | 
		t add: event
	].

	lastDate := nil.
	html table: [
		html 
			tableRow: [
				html 
					tableHeading: 'Date';
					tableHeading: 'Time';
					tableHeading: 'Event';
					tableHeading: 'Duration';
					tableHeading: 'Room'.
				].
		t do: [ :e |
			e scheduled ifTrue: [ 
				(lastDate = e time day) 
					ifFalse: [ html tableData: e time dayOfWeekAbbreviation, ', ', (e time asDate printFormat: #(2 1 0 ' ' 2 1)) ] 
					ifTrue: [ html tableData ].
				html tableData: (String streamContents: [ :aStream | e time asTime print24: true showSeconds: false on: aStream ]).
				lastDate := e time day.
			] ifFalse: [
				(lastDate = #unscheduled) 
					ifFalse: [ html tableData colSpan: 2; with: '(Unscheduled)' ] 
					ifTrue: [ html tableData colSpan: 2].
				lastDate := #unscheduled.
			].
		
			html tableData: e name.
			html tableData: e duration.
			html tableData: (e scheduled ifTrue: [ e room name ])
		]
	]

"			tableData: anEvent time dayOfWeekAbbreviation, ', ', (anEvent time asDate printFormat: #(2 1 0 ' ' 2 1));
			tableData: (String streamContents: [ :aStream | anEvent time asTime print24: true showSeconds: false on: aStream ])
"! !

!CMParticipantView methodsFor: 'as yet unclassified' stamp: 'srh 5/30/2007 23:13'!
style ^ 'div#participantView {
    border-style: solid;
    border-width: 1px;
}

#participantView h3 {
    margin-top: 0;
}
'! !

CMEditor subclass: #CMRoomView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Web'!

!CMRoomView methodsFor: 'as yet unclassified' stamp: 'srh 9/23/2007 13:08'!
addItem: anItem
	^self convention addRoom: anItem! !

!CMRoomView methodsFor: 'as yet unclassified' stamp: 'srh 9/23/2007 13:09'!
newItem
	^CMRoom new! !

!CMRoomView methodsFor: 'as yet unclassified' stamp: 'srh 9/23/2007 13:09'!
removeItem: anItem
	^self convention removeRoom: anItem! !

!CMRoomView methodsFor: 'as yet unclassified' stamp: 'srh 9/23/2007 11:13'!
renderEditFieldsOn: html
	self renderTextInput: 'Capacity' for: #capacity on: html.
	self renderTextArea: 'Description' for: #description on: html.
! !

!CMRoomView methodsFor: 'as yet unclassified' stamp: 'srh 9/23/2007 11:25'!
renderEditTitleOn: html
	self renderTitleField: 'Name' for: #name on: html.! !

!CMRoomView methodsFor: 'as yet unclassified' stamp: 'srh 10/7/2007 20:42'!
renderItemContentOn: html
	html paragraph class: #label; with: 'Capacity'.
	html paragraph
		script: (self inPlaceEditorFor: #capacity on: html);
		with: self item capacity.
		
	html paragraph class: #label; with: 'Info'.	
	html paragraph 
		script: (self inPlaceEditorFor: #description on: html rows: 6);
		with: [html html: self item description] .
! !

!CMViewer class methodsFor: 'as yet unclassified' stamp: 'srh 5/31/2007 22:06'!
for: anItem
	^self new item: anItem; yourself.! !

!CMViewer methodsFor: 'rendering' stamp: 'srh 9/23/2007 10:46'!
allModes
	^(OrderedCollection with: #details) addAll: self modes; yourself! !

!CMViewer methodsFor: 'rendering' stamp: 'srh 9/23/2007 10:50'!
initialize
	super initialize.
	mode := #details.
	item := nil.! !

!CMViewer methodsFor: 'as yet unclassified' stamp: 'srh 5/31/2007 21:37'!
item
	^item! !

!CMViewer methodsFor: 'as yet unclassified' stamp: 'srh 5/31/2007 22:52'!
item: anItem
	item := anItem! !

!CMViewer methodsFor: 'as yet unclassified' stamp: 'srh 9/23/2007 10:32'!
modes
	^#()! !

!CMViewer methodsFor: 'rendering' stamp: 'srh 9/23/2007 11:31'!
renderContentOn: html
	item ifNotNil: [
		self renderHeadingOn: html.
			html unorderedList 
			class: #itemTabs;
			with: [ self renderNavOn: html ].
		html div 
			id: #viewContent; 
			with: [	self renderItemContentOn: html.	].
]! !

!CMViewer methodsFor: 'rendering' stamp: 'srh 6/3/2007 20:22'!
renderHeadingOn: html
	item ifNotNil: [
		html heading 
			level: 3;
			script: (self inPlaceEditorFor: #name on: html);
		 	with: item name.
	]! !

!CMViewer methodsFor: 'rendering' stamp: 'srh 9/23/2007 10:55'!
renderItemContentOn: html
	self perform: ('render', mode capitalized , 'On:' ) asSymbol with: html.
	html span class: #fixFloats.
	(mode = #details) ifTrue: [
		html form: [ html submitButton value: 'Edit';callback: [ mode := #edit ] ]
	].
! !

!CMViewer methodsFor: 'rendering' stamp: 'srh 9/23/2007 11:18'!
renderNavOn: html
	self allModes do: [ :m |
		html listItem 
			class: ((mode = m) ifTrue: [#active]);
			with: [
				(mode = #edit) ifFalse: [
					html anchor 
						callback: [ mode := m ];
						with: m asCapitalizedPhrase.
				] ifTrue: [
					html span with: m asCapitalizedPhrase.
				]
			]
		].! !

TestCase subclass: #CMConventionTest
	instanceVariableNames: 'c e r p time'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core-Tests'!

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:09'!
assertDeserialization: c2
	" Check that c2 is the same as c as set up by standardSetUp"
	| e2 r2 p2 tt |

	self assert: c name = c2 name.
	
	" Verify the basic collections are the same - as far as we can "
	self assert: c rooms size = c2 rooms size.
	self assert: c events size = c2 events size.
	self assert: c participants size = c2 participants size .

	" Now ensure the relationships are kept "
	e2 := c2 events asOrderedCollection at: 1.
	r2 := c2 rooms asOrderedCollection at: 1.
	p2 := c2 participants asOrderedCollection at: 1.
	tt := p2 timetable at: 1.
		
	self assert: r2 = e2 room.
	self assert: e2 = (r2 events asOrderedCollection at: 1).
	self assert: e2 = tt event.
	self assert: r2 = tt room.
	self assert: time = tt time.
	! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:24'!
setUp
	c := CMConvention new name: 'A Convention'.
	e := CMEvent new name: 'An Event'; description: 'Stuff Happens'.
	r := CMRoom new name: 'A Room'; description: 'It has four walls'; capacity: '20'.
	p := CMParticipant new name: 'A Participant'.
	time := '2007-10-01T10:00:00' asDateAndTime.
! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/29/2007 23:22'!
standardSetUp
	c addEvent: e; addRoom: r; addParticipant: p.
	p attend: e.
	r schedule: e at: time.
! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:17'!
tearDown
	c := nil.
	e := nil.
	r := nil.
	p := nil.
	time := nil.! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:00'!
testAddEvents
	c addEvent: e.
	self assert: (c events includes: e).! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:00'!
testAddParticipants
	c addParticipant: p.
	self assert: (c participants includes: p).! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 21:00'!
testAddRooms
	c addRoom: r.
	self assert: (c rooms includes: r).! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:21'!
testLoadSave
	| c2 |
	self standardSetUp.
	c saveAs: 'testingfile'.
	
	c2 := CMConvention loadFrom: 'testingfile'.
	self assertDeserialization: c2.! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:17'!
testRemoveEvent
	self	standardSetUp.
	c removeEvent: e.
	
	self assert: (c events includes: e) not.
	self assert: (r events includes: e) not.
	self assert: (p events includes: e) not.! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:17'!
testRemoveParticipant
	self standardSetUp.
	
	c removeParticipant: p.
	
	self assert: (c participants includes: p) not.
	self assert: (e participants includes: p) not.
! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:18'!
testRemoveRoom
	self standardSetUp.
		
	c removeRoom: r.
	
	self assert: (c rooms includes: r) not.
	self assert: (e scheduled) not.
	self assert: e room isNil.
	self assert: (p timetable noneSatisfy: [ :s | s room = r ]).! !

!CMConventionTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 22:19'!
testSerialiseDeserialise
	| c2 string |
	self standardSetUp.
	string := c serialize.
	
	c2 := CMConvention deserialize: string.
	self assertDeserialization: c2.! !

TestCase subclass: #CMEventTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core-Tests'!

!CMEventTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:16'!
assert: anEvent scheduledAt: aDateAndTime in: aRoom
	self assert: anEvent scheduled.
	self assert: (aRoom events includes: anEvent).
	self assert: (aRoom scheduleFor: anEvent) = aDateAndTime.
	self assert: anEvent time = aDateAndTime.
	self assert: anEvent room == aRoom! !

!CMEventTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 14:57'!
testAdd
	| p e |
	e := CMEvent new.
	p := CMParticipant new.
	e add: p.
	self assert: e participants size = 1.
	self assert: (e participants includes: p).
	self assert: p events size = 1.
	self assert: (p events includes: e).! !

!CMEventTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 15:24'!
testDeschedule
	| e1 r1 |
	r1 := CMRoom new.
	e1 := CMEvent new.
	
	e1 scheduleAt: '2007-10-01T09:00:00' asDateAndTime in: r1.	
	e1 deschedule.
	self assert: r1 events size = 0.
	
! !

!CMEventTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 07:16'!
testRemove
	| e1 p1 |
	p1 := CMParticipant new.
	e1 := CMEvent new.
	
	e1 add: p1.
	e1 remove: p1.
	self assert: e1 participants size = 0.
	self assert: p1 events size = 0.! !

!CMEventTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 15:25'!
testReschedule
	| e1 r1 r2 t1 t2 |
	r1 := CMRoom new.
	r2 := CMRoom new.
	e1 := CMEvent new.
	t1 := '2007-10-01T09:00:00' asDateAndTime.
	t2 := '2007-10-02T17:00:00' asDateAndTime.
	
	e1 scheduleAt: t1 in: r1.	
	e1 scheduleAt: t2 in: r1.
	self assert: e1 scheduledAt: t2 in: r1.
	
	self assert: r1 events size = 1.
	
	e1 scheduleAt: t1 in: r2.
	self assert: e1 scheduledAt: t1 in: r2.
	self assert: r1 events size = 0.
	
	e1 deschedule.
	self assert: r1 events size = 0.
	self assert: r2 events size = 0.
	self assert: e1 scheduled not.
	
! !

!CMEventTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 15:23'!
testSchedule
	| e1 r1 t1 |
	r1 := CMRoom new.
	e1 := CMEvent new.
	t1 := '2007-10-01T09:00:00' asDateAndTime.
	
	e1 scheduleAt: t1 in: r1.	
	self assert: e1 scheduledAt: t1 in: r1.! !

TestCase subclass: #CMParticipantTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core-Tests'!

!CMParticipantTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 14:58'!
testAttend
	| p e |
	e := CMEvent new.
	p := CMParticipant new.
	p attend: e.
	self assert: p events size = 1.
	self assert: (p events includes: e).
	self assert: e participants size = 1.
	self assert: (e participants includes: p).
! !

!CMParticipantTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:14'!
testTimetable
	| e1 r1 e2 r2 p t1 t2 |
	
	p := CMParticipant new.
	e1 := CMEvent new.
	e2 := CMEvent new.
	r1 := CMRoom new.
	r2 := CMRoom new.
	t1 := '2007-10-01T09:30:00' asDateAndTime.
	t2 := '2007-10-01T015:00:00' asDateAndTime.

	r1 schedule: e1 at: t1.
	r2 schedule: e2 at: t2.
	
	p attend: e1.
	p attend: e2.
	
	self assert: (p timetable at: 1) room = r1.
	self assert: (p timetable at: 1) event = e1.
	self assert: (p timetable at: 1) time = t1.
	
	self assert: (p timetable at: 2) room = r2.
	self assert: (p timetable at: 2) event = e2.
	self assert: (p timetable at: 2) time = t2.! !

!CMParticipantTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 07:20'!
testUnattend
	| e1 p1 |
	p1 := CMParticipant new.
	e1 := CMEvent new.
	
	e1 add: p1.
	p1 unattend: e1.
	self assert: e1 participants size = 0.
	self assert: p1 events size = 0.! !

TestCase subclass: #CMRoomTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Conman-Core-Tests'!

!CMRoomTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:16'!
assert: anEvent scheduledAt: aDateAndTime in: aRoom
	self assert: anEvent scheduled.
	self assert: (aRoom events includes: anEvent).
	self assert: (aRoom scheduleFor: anEvent) = aDateAndTime.
	self assert: anEvent time = aDateAndTime.
	self assert: anEvent room == aRoom! !

!CMRoomTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:00'!
testDeschedule
	| e1 r1 |
	r1 := CMRoom new.
	e1 := CMEvent new.
	
	r1 schedule: e1 at: '2007-10-01T09:00:00' asDateAndTime.
	r1 deschedule: e1.
	self assert: r1 events size = 0.
	
! !

!CMRoomTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:03'!
testReschedule
	| e1 r1 r2 t1 t2 |
	r1 := CMRoom new.
	r2 := CMRoom new.
	e1 := CMEvent new.
	t1 := '2007-10-01T09:00:00' asDateAndTime.
	t2 := '2007-10-02T17:00:00' asDateAndTime.
	
	r1 schedule: e1 at: t1.	
	r1 schedule: e1 at: t2.
	self assert: e1 scheduledAt: t2 in: r1.
	self assert: r1 events size = 1.
	
	r2 schedule: e1 at: t1.
	self assert: e1 scheduledAt: t1 in: r2.
	self assert: r1 events size = 0.
	
	r2 deschedule: e1.
	self assert: r1 events size = 0.
	self assert: r2 events size = 0.
	self assert: e1 scheduled not.
	
! !

!CMRoomTest methodsFor: 'as yet unclassified' stamp: 'srh 5/24/2007 20:03'!
testSchedule
	| e1 r1 t1 |
	r1 := CMRoom new.
	e1 := CMEvent new.
	t1 := '2007-10-01T09:00:00' asDateAndTime.
	
	r1 schedule: e1 at: t1.	
	self assert: e1 scheduledAt: t1 in: r1.! !
CMConvention initialize!
